unit uoddface_roscon_cfg;
{$mode delphi}
interface
// Esta unidad define la configuraciónd e conexión de los demonios de OddFace
// por defecto se suministra una configuración que no es operativa y debe
// sustituirse por la configuración que corresponda en cada caso.
uses
  Classes, SysUtils,
  urosx;


var
  dbcon_rosx: TDBrosxCon;

implementation
var
  ipfija_rosx: string; // si se inicializa no se consulta la ip
  host_rosx: string; // se usa si ipfija='' para buscar la ip
  puerto_rosx: integer; // por defecto es 80
  uri_rosx: string; // Por ej: '/simsee/ros/rosx.php';

initialization

{$I oddface_rosx.cfg}
dbcon_rosx:= TDBrosxCon.Create( ipfija_rosx , host_rosx, puerto_rosx, uri_rosx );

finalization
if dbcon_rosx <> nil then  dbcon_rosx.Free;

end.

