unit uEvaluadorDeExpresionesSimple;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, StdCtrls,
  uparseadorsupersimple;

type

  { TForm1 }

  TForm1 = class(TForm)
    btEvaluar: TButton;
    eExpresion: TMemo;
    eResultado: TMemo;
    procedure btEvaluarClick(Sender: TObject);
  private
    { private declarations }
  public
    { public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

{ TForm1 }

procedure TForm1.btEvaluarClick(Sender: TObject);
var
  s: string;
  tokens: TTokensLst;
  nodo: TNodoToken;
  k: integer;
  aEvaluador: TEvaluadorExpresionesSimples;
  exp: TExpresion;
begin
  aEvaluador:= TEvaluadorExpresionesSimples.Create;
  s:= eExpresion.Text;
  tokens:= aEvaluador.tokenParser( s );

  eResultado.Lines.Clear;
  for k:= 0 to tokens.Count -1 do
  begin
    nodo:= TNodoToken( tokens[k] );
    eResultado.Lines.Add( aEvaluador.TipoTokenName( nodo.tipo )+': '+ nodo.val) ;
  end;

  exp:= aEvaluador.GetFullExpresion( tokens );
  exp.evaluar;
  tokens.Free;
end;

end.

