unit SelectTypeUnit;

{$mode delphi}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, StdCtrls,
  ucosa;

type

  { TSelectTypeForm }

  TSelectTypeForm = class(TForm)
    AceptarButton: TButton;
    ListBox1: TListBox;
    ParentLabel: TLabel;
    procedure AceptarButtonClick(Sender: TObject);
  private
    { private declarations }
  public
    ClaseDeCosaChild:TClaseDeCosa;
    procedure UpdateListBox(DataVTable: TDataVTableOfCosa);
  end;

var
  SelectTypeForm: TSelectTypeForm;

implementation

uses
  uFormEditSimSEE;

{$R *.lfm}

{ TSelectTypeForm }

procedure TSelectTypeForm.AceptarButtonClick(Sender: TObject);
var
  CosaStrId:string;
begin
  CosaStrId:=self.ListBox1.GetSelectedText;
  self.ClaseDeCosaChild:=TClaseDeCosa(getClaseOf(CosaStrId));
  ModalResult := mrOK;
end;

procedure TSelectTypeForm.UpdateListBox(DataVTable:TDataVTableOfCosa);
var
  i: Integer;
  ChildClassName:string;
begin
  //DataVTable:=TDataVTableOfCosa(DATA_STORE.GetDataTableByName(DataVTableName));
  for i:=0 to DataVTable.ChildClassNameList.Count-1 do
  begin
    ChildClassName:=DataVTable.ChildClassNameList[i];
    //ListBox1.Items.Add(TFichaClase(registro_de_ClasesDeCosas.items[i]).strClaseId);
    ListBox1.Items.Add(ChildClassName);
  end;
end;

end.

