unit uRegistroDeEditores;

{$mode delphi}

interface

uses
  Classes, SysUtils, ucosa, uInfoCosa,
  uBaseEditores,
  LResources,
  EditBtn, DbCtrls,
  uEditarMemo,
  ueditarfichafuentetiempo, ufuentetiempo,
  ueditarfichafuentesinusoide, ufuentesinusoide,
  ueditarfichafuentemaxmin, ufuentemaxmin, uEditarTGTer_Combinado,
  uEditarTMercadoSpot_postizado, uEditarFichaGTer_combinado,
  uEditarFichaMercadoSpot_postizado, uEditarFichaMercadoSpot_postizado_Fuentes,
  {$IFDEF CON_CALIBRADOR}
  ucalibrador,
  {$ENDIF}
  //TreeFilterEdit,
  {$IFDEF WINDOWS}
  Windows,
  {$ELSE}
  LCLType,
  {$ENDIF}
  xmatdefs, ufechas, utilidades, utrazosxy,
  uConstantesSimSEE, uFormEditarOpciones, uAuxiliares,
  uFormularioBase, uBaseFormularios, uverdoc, uversiones, usalasdejuego, usalasdejuegoParaEditor,
  uListaMantenimientos, uEditarFichaUnidades, ucosaparticipedemercado,
  uActorNodal,
  uActores,
  ugter_basico,
  ugter_arranqueparada,
  ugter_onoffporpaso,
  ugter_onoffporposte,
  ugter_combinado,
  usolartermico,
  usolarPV,
  ubiomasaembalsable,
  unodos,
  unodocombustible,
  uarcocombustible,
  ugsimple_bicombustible,
  uDemandaCombustibleAnioBaseEIndices,
  uTSumComb,
  ueditarsumcomb,
  ueditarfichasumcomb,
  ueditartgsimple_bicombustible,
  ueditarfichagsimple_bicombustible,
  uEditarFichaArcoCombustible,
  uEditarTArcoCombustible,
  uEditarTDemandaCombustibleAnioBaseEIndices,
  uDemandas,
  udemandas01,
  uDemandaAnioBaseEIndices,
  uDemandaDetallada,
  uArcos,
  uArcoConSalidaProgramable,
  uCombustible,
  uHidroConEmbalse,
  uHidroConBombeo,
  uGeneradores,
  uCosaConNombre,
  uHidroDePasada,
  uMercadoSpot,
  uMercadoSpot_postizado,
  uParqueEolico,
  uParqueEolico_vxy,
  ugter_basico_TRep,
  ugter_basico_PyCVariable,
  ucontratomodalidaddevolucion,
  uComercioInternacional,
  uMercadoSpotConDetalleHorarioSemanal,
  ugter_onoffporpaso_conrestricciones,
  uHidroConEmbalseBinacional,
  uEditorSimRes3Main,
  uOpcionesSimSEEEdit,
  uBaseEditoresCosasConNombre,
  uEditarTNodo,
  uEditarTContratoModalidadDevolucion,
  uEditarTArco,
  uEditarTArcoConSalidaProgramable,
  uEditarTDemanda01,
  uEditarTDemandaAnioBaseEIndices,
  uEditarTDemandaDetallada,
  uEditarTGTer,
  uEditarTGTer_ArranqueParada,
  uEditarTGTer_Basico_TRep,
  ueditarTSolarTermico,
  ueditarTSolarPV,
  uEditarTBiomasaEmbalsable,
  uEditarTGTer_Basico_PyCVariable,
  uEditarTGTer_OnOffPorPaso_ConRestricciones,
  uEditarTHidroConEmbalse,
  uEditarTHidroConBombeo,
  uEditarTHidroConEmbalseBinacional,
  uEditarTHidroDePasada,
  uEditarTBaseMercadoSpot,
  uEditarTParqueEolico,
  uEditarTParqueEolico_vxy,
  uManejadoresDeMonitores,
  uReferenciaMonitor, uReferenciaMonitorConsola, uReferenciaMonitorGraficoSimple,
  uReferenciaMonArchivo, uReferenciaMonHistograma, uReferenciaMonSimRes,
  uBaseAltasMonitores, uAltaMonitorConsola, uAltaMonitorGrafico, uAltaMonArchivo,
  uAltaMonHistograma, uAltaMonSimRes,
  uFuentesAleatorias,
  uFuenteConstante, uFuenteUniforme, uFuenteGaussiana, uFuenteWeibull,
  uFuenteSintetizador, uFuenteCombinacion, uFuenteProducto, uFuenteSelector,
  uFuenteSelector_horario,
  uEditarFichaFuenteSelector_horario,
  uEditarFuentesSimples, uEditarFuenteSintetizador,
  uEditarFichaFuenteUniforme, uEditarFichaFuenteGaussiana, uEditarFichaFuenteConstante,
  uEditarFichaFuenteWeibull, uEditarFichaFuenteCombinacion,
  uEditarFichaFuenteProducto, uEditarFichaFuenteSelector,
  uEditarFichaGTer_Basico, uEditarFichaGTer_ArranqueParada,
  uEditarFichaGTer_OnOffPorPaso, uEditarFichaGTer_OnOffPorPoste,
  uEditarFichaSolarTermico, uEditarFichaSolarPV,
  uEditarFichaBiomasaEmbalsable,
  uEditarTCombustible,
  uEditarFichaCombustible,

  // {$IFDEF REGAS}

  uEditarRegasificadora,
  uRegasificadora,
  uEditarFichaRegasificadora,
  //{$ENDIF}

  uEditarFichaDemanda01, uEditarFichaHidroConEmbalse,
  uEditarFichaHidroConBombeo,
  uEditarFichaHidroDePasada,
  uEditarFichaArco,
  uEditarFichaArcoConSalidaProgramable,
  uEditarFichaMercadoSpot, uEditarFichaGTer_Basico_TRep,
  uEditarFichaGTer_Basico_PyCVariable,
  uEditarFichaContratoModalidadDevolucion, uEditarFichaMercadoSpotConDetalleHorario,
  uEditarFichaGTer_OnOffPorPaso_ConRestricciones,
  uEditarFichaHidroConEmbalseBinacional,
  uEditarFichaUsoGestionable_postizado, uEditarTUsoGestionable_postizado,
  ubancodebaterias01, ueditartbancodebaterias01, ueditarfichabancodebaterias01,
  uusogestionable_postizado,
  uInfoTabs, uFormSelectTipo, uFormExportar,
  uEstados, uEditarEnganches,
  uInterpreteDeParametros,
  uComponerCFs,
  ulst_generadores,
  types,
  uFlucar, urawdata,
  uvisordetabla,
  ulst_plantillassimres3,
  ulst_escenarios,
  uescenarios,
  //uEditorEscenario,
  ueditor_resourcestrings,
  uEditarTNodoCombustible,
  uvisorgraficomantenimientos

  (***)
  //uFormFuenteSimple,
  //uFormFichaFuenteConstante
  (***)

  ;

procedure AlInicio;
procedure AlFinal;

procedure RegistrarEditoresActores;
procedure RegistrarEditoresFuentes;

{$IFDEF MIGRACION_PERSISTENCIA}
function OpenForm(AOwner: TFormularioBase; xCosaStrId:string; xDataSet:TDataStore=nil; xTitle:string=''):TFormularioBase;
{$ENDIF}

var

  RegistroEditores: TListaInfoCosas;


implementation

uses
//****** ******
   SimSEEEditMain;
//****** ******

procedure AlInicio;
begin

  //RegistroEditores.Add(TInfoCosa.Create('TEscenario_rec', 'Escenario', TEditorEscenario));

  RegistrarEditoresActores;

  RegistrarEditoresFuentes;

end;

procedure AlFinal;
begin

end;

procedure RegistrarEditoresActores;
begin

  SimSEEEditMain.TFSimSEEEdit.registrarActores;

//  registroEditores.Add(TInfoCosa.Create('TArco','',TTNodoCombustible ));


end;

procedure RegistrarEditoresFuentes;
begin

//****
  //Esto es necesario mientras coexistan ventanas de los 2 editores
  SimSEEEditMain.TFSimSEEEdit.registrarFuentes;
//****
  //registroEditores.Add(TInfoCosa.Create('TFuenteConstante',      'Fuente Constante',              TFormFuenteSimple));
  // registroEditores.Add(TInfoCosa.Create('TFichaFuenteConstante', 'Ficha LPD De Fuente Constante', TFormFichaFuenteConstante));

  registroEditores.Add(TInfoCosa.Create('TFuenteUniforme','',TEditarFuentesSimples));
  registroEditores.Add(TInfoCosa.Create('TFichaFuenteUniforme','',TEditarFichaFuenteUniforme));

  registroEditores.Add(TInfoCosa.Create('TFuenteGaussiana','',TEditarFuentesSimples));
  registroEditores.Add(TInfoCosa.Create('TFichaFuenteGaussiana','',TEditarFichaFuenteGaussiana));

  registroEditores.Add(TInfoCosa.Create('TFuenteWeibull','',TEditarFuentesSimples));
  registroEditores.Add(TInfoCosa.Create('TFichaFuenteWeibull','',TEditarFichaFuenteWeibull));

  registroEditores.Add(TInfoCosa.Create('TFuenteCombinacion','',TEditarFuentesSimples));
  registroEditores.Add(TInfoCosa.Create('TFichaFuenteCombinacion','',TEditarFichaFuenteCombinacion));

  registroEditores.Add(TInfoCosa.Create('TFuenteProducto','',TEditarFuentesSimples));
  registroEditores.Add(TInfoCosa.Create('TFichaFuenteProducto','',TEditarFichaFuenteProducto));

  registroEditores.Add(TInfoCosa.Create('TFuenteSintetizadorCEGH','',TEditarFuenteSintetizador));

  registroEditores.Add(TInfoCosa.Create('TFuenteTiempo','',TEditarFuentesSimples));
  registroEditores.Add(TInfoCosa.Create('TFichaFuenteTiempo','',TEditarFichaFuenteTiempo));

  registroEditores.Add(TInfoCosa.Create('TFuenteSinusoide','',TEditarFuentesSimples));
  registroEditores.Add(TInfoCosa.Create('TFichaFuenteSinusoide','',TEditarFichaFuenteSinusoide));

  registroEditores.Add(TInfoCosa.Create('TFuenteMaxMin','',TEditarFuentesSimples));
  registroEditores.Add(TInfoCosa.Create('TFichaFuenteMaxMin','',TEditarFichaFuenteMaxMin));

  registroEditores.Add(TInfoCosa.Create('TFuenteSelector','',TEditarFuentesSimples));
  registroEditores.Add(TInfoCosa.Create('TFichaFuenteSelector','',TEditarFichaFuenteSelector));

  //registroEditores.Add(TInfoCosa.Create('TFuenteSelector_horario','',TEditarFuentesSimples));
  //registroEditores.Add(TInfoCosa.Create('TFichaFuenteSelector_horario','',TEditarFichaFuenteSelector_horario));

  writeln(SizeOf(TEditarFichaFuenteSelector_horario));

end;

{$IFDEF MIGRACION_PERSISTENCIA}
function OpenForm(AOwner: TFormularioBase; xCosaStrId: string;
  xDataSet: TDataStore; xTitle: string): TFormularioBase;
var
  FormType: FormBaseClass;
  AForm: TFormularioBase;
  ACosa: TCosa;
  ACosaConNombre: TCosaConNombre;
  dt: String;
  b: String;
  sala:TSalaDeJuego;
  sval: string;
  res:TListaDeCosasConNombre;

  tipoCosa:TClass;
  index: integer;
  nombre: String;
  qqq: TStringList;
  ADataSet: TDataStore;
  a: Integer;

  AFormVersion:TFormVersion;
begin

  FormType:=RegistroEditores.getEditorCosa(xCosaStrId);

  if ucosa.IsChild(TBaseFormularios, FormType) then
  begin
    AFormVersion:=TFormVersion.OLD;
    if ucosa.IsChild(TBaseEditores, FormType) then
    begin

      //DATA SET FULL CON LA SALA DE JUEGO, USADO PARA CREAR EL OBJETO
      ADataSet:=TDataStore.Create(nil);
      ADataSet.SetName:='AAAAAAAAA';
      xDataSet.Fill('dt_TSalaDeJuego', 1001, ADataSet);
      ADataSet.CreateClassInstance('dt_TSalaDeJuego', 1001, TCosa(sala));
      resolverReferenciasContraSala(sala, true);

      tipoCosa:=ucosa.getClaseOf(xCosaStrId).ClassType;

      if ucosa.IsChild(TBaseEditoresCosasConNombre, FormType) then
      begin
        nombre:=xDataSet.DataTableList[0].DataRowList[0].DataCellList[xDataSet.DataTableList[0].GetIndexOfDataColumnByName('nombre')].sval;
        acosa:=sala.BuscarPorNombre(nombre, res);

        if acosa.id=0 then
          a:=1;
        AForm:=TClaseEditoresCosasConNombre(FormType).Create(AOwner, sala, tipoCosa, TCosaConNombre(acosa));

      end;
    end;
  end
  else
  begin
    AFormVersion:=TFormVersion.NEW;

    AForm := FormType.Create(AOwner, xDataSet, xTitle);
  end;

  AForm.DataSet:=xDataSet;
  AForm.FormVersion:=AFormVersion;

  Result:=AForm;
end;
{$ENDIF}

initialization

  registroEditores:= TListaInfoCosas.Create;

finalization

  registroEditores.Free;

end.

